/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#ifndef __MFOOTPLACE_H__
#define __MFOOTPLACE_H__

#include "hrpModelHeaders.h"

using namespace OpenHRP;

namespace mwalk_pattern_generator{

  class FootPlace{
  public:
    /// single support period
    int nss;
    /// double support period
    int nds;

    /// support leg (RLEG, LLEG, -1)
    int support_leg;

    /// displacement of foot place
    vector3 p;
    /// direction of foot place
    vector3 rpy;

    /// displacement of waist height
    double  hip_z;

    /// offset of foot attitude
    vector3 frpy;

    /// unique id
    unsigned int uid;

    FootPlace(void){
      nss   = 0;
      nds   = 0;
      support_leg = -1;
      p     = 0.0;
      rpy   = 0.0;
      hip_z = 0.0;
      frpy  = 0.0;
      uid = -1U;
    }
    ~FootPlace(){};
  };
}

#endif // __MFOOTPLACE_H__
