/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#ifndef __MFOOT_STEP_MANAGER_H__
#define __MFOOT_STEP_MANAGER_H__

#include <queue>
#include "hrpModelHeaders.h"
#include "mwalk_common.h"
#include "FootPlace.h"

using namespace OpenHRP;
using namespace std;


namespace mwalk_pattern_generator{

  class FootStepManager{
  public:
    double Foot_distance;
    // step restriction
    int    first_step;
    double STEP_X_FORWARD_MAX;
    double STEP_X_BACK_MAX;
    double STEP_Y_OUT_MAX;
    double STEP_Y_IN_MAX;
    double STEP_Z_UP_MAX;
    double STEP_Z_DOWN_MAX;
    double STEP_YAW_OUT_MAX;
    double STEP_YAW_IN_MAX;

    FootStepManager(double Foot_distance_);
    ~FootStepManager();

    FootStepManager* getFootStepManagerPtr(void){ return this; }
    bool pushFootPlace( deque<FootPlace>& FootQueue_, int support_leg_,
			double x, double y, double z, double th, double tss,
			double tds, double roll, double pitch, double yaw,
			double hip_z, unsigned int uid = -1U);
    void pushFootPlaceNoCheck(deque<FootPlace>& FootQueue_, int support_leg_,
			      double x, double y, double z, double th,
			      double hip_z, double roll, double pitch,
			      double yaw, double tss, double tds,
			      unsigned int uid = -1U);
  };
} // end of namespace mwalk_pattern_generator

#endif // __MFOOTPLACE_H__
