/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#ifndef __LINEAR_CONTROL3_H__
#define __LINEAR_CONTROL3_H__

#include "hrpModelHeaders.h"

using namespace OpenHRP;

namespace linear_control_system{
  
  typedef tvmet::Matrix<double, 1, 3> vector3_t;
  
  // linear control for siso system
  class LinearControl3{
  public:
    // system matrices and feedback gain
    matrix33  A;
    vector3   B;
    vector3_t C;
    vector3   K;
    
    vector3   x;            // state variable
    double    y;            // output
    double    u;            // input
    
    void Initialize(void);
    LinearControl3(void);
    virtual ~LinearControl3(void);
    
    virtual void update(void);
    virtual void update(const double dt);
#if 0
    bool solveDiscreteLQRegulator(vector3& K, matrix33& P, matrix33& Ad, vector3& Bd, vector3_t& Cd, matrix33& Qd, double Rd);
    inline bool solveDiscreteLQRegulator(vector3& K, matrix33& P, matrix33& Ad, vector3& Bd, vector3_t& Cd, double Qd, double Rd){
      vector3  Ct(Cd(0,0), Cd(0,1), Cd(0,2));
      matrix33 CtQC((Cd * Ct) * Qd);
      return solveDiscreteLQRegulator(K, P, Ad, Bd, Cd, CtQC, Rd);
    };
    inline bool solveDiscreteLQRegulator(matrix33& P, matrix33& Qd, double Rd){
      return solveDiscreteLQRegulator(K, P, A, B, C, Qd, Rd);
    };
    inline bool solveDiscreteLQRegulator(matrix33& P, double Qd, double Rd){
      vector3  Ct(C(0,0), C(0,1), C(0,2));
      matrix33 CtQC((Ct * C) * Qd);
      return solveDiscreteLQRegulator(K, P, A, B, C, CtQC, Rd);
    };
    inline bool solveDiscreteLQRegulator(matrix33& Qd, double Rd){
      matrix33 P(tvmet::identity<matrix33>());
      return solveDiscreteLQRegulator(K, P, A, B, C, Qd, Rd);
    };
#endif
  };
  
}; // end of namespace linear_control_system

#endif
