/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#include "MeasureExecTime.h"


MeasureExecTime::MeasureExecTime()
{
  clearExecTime();
}

MeasureExecTime::~MeasureExecTime()
{
}

void MeasureExecTime::clearExecTime(void)
{
  flg_firsttime_exectime = true;
  execT.clear();
  execT_max.clear();
}

void MeasureExecTime::initExecTime(void)
{
  execT.clear();
}

void MeasureExecTime::pushExecTime(void)
{
  gettimeofday(&tv, NULL);
  execT.push_back(tv.tv_sec + tv.tv_usec*1.0e-6);
}

void MeasureExecTime::calcExecTime(void)
{
  if( flg_firsttime_exectime ){
    for( unsigned int i = 0 ; i < execT.size() ; i++ )
      execT_max.push_back(0.0);
    flg_firsttime_exectime = false;
  }
  
  for( unsigned int i = 1 ; i < execT.size() ; i++ ){
    double t_exec = execT[i] - execT[i-1];
    if( t_exec > execT_max[i-1] )
      execT_max[i-1] = t_exec;
  }
  
  double t_exec_total = execT.back() - execT.front();
  if( t_exec_total > execT_max.back() )
    execT_max.back() = t_exec_total;
}
