/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#ifndef __MWALK_FOOT_PLANNER_H__
#define __MWALK_FOOT_PLANNER_H__

#include "FootStepManager.h"

using namespace mwalk_pattern_generator;


namespace foot_planner{
  
  class MwalkFootPlanner{
  private:
    FootStepManager *fsm;
    
  protected:
    void setOmniDirectionalWalk(deque<FootPlace>& FootQueue, double dx_cmd, double dy_cmd, double dyaw_cmd, int nss, int nds, bool verbose);
    
  public:
    MwalkFootPlanner(FootStepManager *fsm_);
    ~MwalkFootPlanner();
    
    void setTargetPos(deque<FootPlace>& FootQueue, double dx_cmd, double dy_cmd, double dyaw_cmd, int nss, int nds, bool verbose = false);
    void setArcWalk(deque<FootPlace>& FootQueue, double cx_cmd, double cy_cmd, double dyaw_cmd, int nss, int nds, bool verbose = false);
    void setTargetPosPassGate(deque<FootPlace>& FootQueue, vector3& gate_pos1, vector3& gate_pos2, vector3& goal_pos, int nss, int nds, bool verbose=false);
  };

} // end of namespace foot_planner

#endif // __MWALK_FOOT_PLANNER_H__
