/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#ifndef __READTEXT_H__
#define __READTEXT_H__

#include <iostream>
#include <fstream>
#include <string>
#include <ublasCommonTypes.h>

using namespace OpenHRP;
using namespace std;


namespace read_text_parameter{
  
  bool GetString( ifstream &in, string& str );
  bool GetString( ifstream &in, char *str );
  void GetVector( ifstream &fs, dvector& V );
  void GetMatrix( ifstream &fs, dmatrix& M );
  void SkipToEOL( istream &in );
  
  template<class T> bool GetData(ifstream& in, T& data, int mode = 0)
    {
      char c;
      in.get(c);
      
      while( !in || c == ' ' || c == '\t' || c== 0x0D || c == '#' || c == 0x0A ){
	if( !in || (mode == 1 && c == 0x0A) )
	  return false;
	
	if( c == '#')
	  while( c != 0x0A) in.get(c);
	in.get(c);
      }
      
      in.putback(c);
      in >> data;
      return true;
    };
  
}; // end of namespace read_text_parameter

#endif // __READTEXT_H__
