/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#include "State.h"


State::State(void)
{
  State::Initialize();
}

State::~State()
{
}

void State::Initialize(void)
{
  P = 0.0;
  V = 0.0;
  Vdot = 0.0;
  R = tvmet::identity<matrix33>();
  R_rpy = 0.0;
  W = 0.0;
  Wdot = 0.0;
  offset = 0.0;
}

void State::Initialize(int leg, double foot_distance)
{
  State::Initialize();
  
  if( leg == RIGHT_LEG ){
    P(Y)      = -foot_distance / 2.0;
    offset(Y) = -foot_distance / 2.0;
  }
  else if( leg == LEFT_LEG ){
    P(Y)      =  foot_distance / 2.0;
    offset(Y) =  foot_distance / 2.0;
  }
}
