/*
 * Copyright (c) 2009,
 * @author Mitsuharu Morisawa
 *
 * AIST
 *
 * All rights reserved.
 *
 * This program is made available under the terms of the Eclipse Public License
 * v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 */
#ifndef __MPHYSICS_H__
#define __MPHYSICS_H__

#ifndef X
#define X (0)
#endif

#ifndef Y
#define Y (1)
#endif

#ifndef Z
#define Z (2)
#endif

#ifndef Gv
#define Gv (9.80)
#endif

#ifndef DT
#define DT (0.005)
#endif

#ifndef  ToDeg
#define ToDeg(a)  (a * 180.0 /  M_PI)          /* from radian to degree    */
#endif
#ifndef  ToRad
#define ToRad(a)  (a * M_PI / 180.0)           /* from degree to radian    */
#endif

#ifndef  RadToDeg
#define RadToDeg  (180.0 /  M_PI)              /* from radian to degree    */
#endif
#ifndef  DegToRad
#define DegToRad  (M_PI / 180.0)               /* from degree to radian    */
#endif

#ifndef Max
#define Max(a,b) ((a) > (b) ? (a) : (b)) 
#endif

#ifndef Min
#define Min(a,b) ((a) < (b) ? (a) : (b)) 
#endif

#ifndef Sign
#define Sign(x) ((x < 0) ? (-1) : ((x > 0) ? 1 : 0))
#endif

#ifndef Pow2
#define Pow2(a) dot((a),(a))
#endif

#endif // __MPHYSICS_H__
